﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Charts;

namespace GridColumnsSeriesSynch
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = ChartData.GenerateData(1000);
            xamGrid1.SelectedColumnsCollectionChanged 
                += new EventHandler<SelectionCollectionChangedEventArgs<SelectedColumnsCollection>>(xamGrid1_SelectedColumnsCollectionChanged);
        }

        void xamGrid1_SelectedColumnsCollectionChanged(object sender, SelectionCollectionChangedEventArgs<SelectedColumnsCollection> e)
        {

            foreach (Series ser in xamDataChart1.Series)
            {
                ser.Visibility = System.Windows.Visibility.Collapsed;
            }
            foreach (Column column in e.NewSelectedItems)
            {
                LineSeries series
                    = xamDataChart1.Series.Where(s => (s as LineSeries).ValueMemberPath.Equals(column.Key)).FirstOrDefault() as LineSeries; 
                if (series != null)
                {
                    series.Visibility = System.Windows.Visibility.Visible;
                }
            }
        }
    }

    public class ChartData
    {
        public DateTime Date { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Date = DateTime.Now,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Date = DateTime.Now.AddDays(i),
                };

                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }

}
